#!/bin/bash

# 步骤 1: 重命名原有的ffmpeg文件，以备份
echo "正在备份原有的ffmpeg文件..."
mv -n /var/packages/VideoStation/target/bin/ffmpeg /var/packages/VideoStation/target/bin/ffmpeg.orig

# 步骤 2: 下载新的ffmpeg wrapper脚本
echo "正在下载新的ffmpeg wrapper脚本..."
wget -O - https://gist.githubusercontent.com/BenjaminPoncet/bbef9edc1d0800528813e75c1669e57e/raw/ffmpeg-wrapper > /var/packages/VideoStation/target/bin/ffmpeg

# 步骤 3: 更改ffmpeg文件的所有者和权限
echo "正在更改ffmpeg文件的所有者和权限..."
chown root:VideoStation /var/packages/VideoStation/target/bin/ffmpeg
chmod 750 /var/packages/VideoStation/target/bin/ffmpeg
chmod u+s /var/packages/VideoStation/target/bin/ffmpeg

# 步骤 4: 备份libsynovte.so文件
echo "正在备份libsynovte.so文件..."
cp -n /var/packages/VideoStation/target/lib/libsynovte.so /var/packages/VideoStation/target/lib/libsynovte.so.orig
chown VideoStation:VideoStation /var/packages/VideoStation/target/lib/libsynovte.so.orig

# 步骤 5: 修改libsynovte.so文件以支持更多的音频编码格式
echo "正在修改libsynovte.so以支持更多音频编码格式..."
sed -i -e 's/eac3/3cae/' -e 's/dts/std/' -e 's/truehd/dheurt/' /var/packages/VideoStation/target/lib/libsynovte.so

# 步骤 6: 备份CodecPack的ffmpeg41文件
echo "正在备份CodecPack的ffmpeg41文件..."
cp /var/packages/CodecPack/target/bin/ffmpeg41 /var/packages/CodecPack/target/bin/ffmpeg41.bak

# 步骤 7: 替换CodecPack的ffmpeg41文件为新下载的ffmpeg文件
echo "正在替换CodecPack的ffmpeg41文件..."
cp /var/packages/VideoStation/target/bin/ffmpeg /var/packages/CodecPack/target/bin/ffmpeg41

# 步骤 8: 重启VideoStation服务
echo "正在重启VideoStation服务..."
sudo synopkg restart VideoStation

echo "脚本执行完毕。"
